=== modified file 'bzrlib/selftest/testtestament.py'
--- bzrlib/selftest/testtestament.py	2005-10-13 01:52:29 +0000
+++ bzrlib/selftest/testtestament.py	2005-10-13 02:01:15 +0000
@@ -97,3 +97,9 @@
   file src/foo.c
 """
         self.assertEqualDiff(text_form, expect)
+        actual_short = t.as_short_text()
+        self.assertEqualDiff(actual_short, """\
+bazaar-ng testament short form 1
+revision test@user-2
+sha1 e64f0a98937f8b0d2602ea5f521938752b90a430
+""")

=== modified file 'bzrlib/testament.py'
--- bzrlib/testament.py	2005-10-13 01:52:29 +0000
+++ bzrlib/testament.py	2005-10-13 02:01:15 +0000
@@ -66,6 +66,7 @@
 
 from cStringIO import StringIO
 import string
+import sha
 
 
 def contains_whitespace(s):
@@ -144,3 +145,11 @@
         self.text_form_1_to_file(s)
         return s.getvalue()
 
+    def as_short_text(self):
+        """Return short digest-based testament."""
+        s = sha.sha(self.to_text_form_1())
+        return ('bazaar-ng testament short form 1\n'
+                'revision %s\n'
+                'sha1 %s\n'
+                % (self.revision_id, s.hexdigest()))
+

